import roof_draw.templates as templates
import roof_draw.utils as utils
from qgis.core import QgsProject, QgsProviderRegistry
import os.path
import os

def run_multi_area():
    # Create the dialog with elements (after translation) and keep reference
    # Only create GUI ONCE in callback, so that it will only load when the plugin is started
    if utils.first_start_area_divide == True:
        utils.first_start_area_divide = False
        utils.DLG_AREA_DIVIDER = templates.RoofDrawAreaDividerDialog()
    
    utils.populate_select_layers_shp(utils.DLG_AREA_DIVIDER.comboBox_camada)
    

    utils.DLG_AREA_DIVIDER.show()
    # Run the dialog event loop
    result = utils.DLG_AREA_DIVIDER.exec_()
    if result:
        ok_multi_area()

def ok_multi_area():
    camada = utils.DLG_AREA_DIVIDER.comboBox_camada.currentText()
    description_text = utils.DLG_AREA_DIVIDER.description_text.text()
    hspacing = utils.DLG_AREA_DIVIDER.hspacing.text()
    vspacing = utils.DLG_AREA_DIVIDER.vspacing.text()
    if (camada!= "" and description_text !="" and hspacing != "" and vspacing != ""):
        layer = QgsProject.instance().mapLayersByName(camada)[0]
        print(camada)
        utils.insert_into_roof_drawing_area_multiple(utils.CONNECTION, layer, description_text, int(hspacing), int(vspacing))
        utils.iface.messageBar().pushMessage("INFO", "Areas Criadas com Sucesso!", level=0)

