import roof_draw.templates as templates
import roof_draw.utils as utils

import os.path
import os

""" Classificador form 3 inicializa o form para classificão das features"""
def initialize_classifier():
    pass

'''carrega tipos na caixa de selecao'''
def populate_select_types():
    utils.DLG_CLASSIFIER.combo_box_classifier.addItems(utils.DEFAULT_TYPES)

"""acao botao ok"""
def ok_classify():
    roof_type = utils.DLG_CLASSIFIER.combo_box_classifier.currentText()
    if (roof_type!= ""):
        classify( roof_type)

""" atualiza o campo roof_type das features selecionadas """
def classify(roof_type):
    # pega as features selecionadas
    current_layer_name = utils.iface.activeLayer().name()
    if current_layer_name == 'roof_drawing_fix':
        layer = utils.iface.activeLayer()
        features = layer.selectedFeatures()
        for feature in features:
            id_pk = str(feature.attribute("id_pk"))
            update_feature(roof_type, id_pk)
        utils.iface.messageBar().pushMessage("INFO", "Features classificadas", level=0)
        utils.DLG_CLASSIFIER.destroy()
    else:
        utils.iface.messageBar().pushMessage("ERRO", "Camada não permitida para classificação!, classificação permitida somente para roof_drawing_fix!", level=1)

# QgsAbstractDatabaseProviderConnection
def update_feature(roof_type, id_pk_fix):
    conn = utils.CONNECTION

    sql_update_original = f"""UPDATE roof_drawing SET flag = true, roof_type ='{roof_type}' WHERE id_pk in (SELECT 
        c.id_pk
        FROM (SELECT b.id_pk,
                (SELECT (ST_Dump(ST_Union(d.the_geom)::geometry)).geom as the_geom
                FROM roof_drawing d WHERE d.id_pk = b.id_pk
                GROUP BY d.quadrante_id, d.roof_type, d.flag, d.dn) as the_geom
            FROM roof_drawing b
            ) as c, roof_drawing_fix as a
        WHERE ST_Equals(c.the_geom, a.the_geom) and a.id_pk={id_pk_fix})"""
    conn.executeSql(sql_update_original)
    sql_update_copy = f"UPDATE roof_drawing_fix SET flag = true , roof_type ='{roof_type}' WHERE id_pk={id_pk_fix}"
    conn.executeSql(sql_update_copy)

def run_classifier():
    """Run method that performs all the real work"""
    # Create the dialog with elements (after translation) and keep reference
    # Only create GUI ONCE in callback, so that it will only load when the plugin is started
    if utils.first_start_classifier == True:
        utils.first_start_classifier = False
        utils.DLG_CLASSIFIER = templates.RoofDrawClassifierDialog()
        initialize_classifier()
        populate_select_types()
    # show the dialog
    utils.DLG_CLASSIFIER.show()
    # Run the dialog event loop
    result = utils.DLG_CLASSIFIER.exec_()
    if result:
        ok_classify()